
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ContactsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const contacts = await db.contacts.create(
            {
                id: data.id || undefined,
        
        contact_name: data.contact_name
        ||
        null
            ,
            
        email: data.email
        ||
        null
            ,
            
        phone: data.phone
        ||
        null
            ,
            
        role_title: data.role_title
        ||
        null
            ,
            
        is_primary: data.is_primary
        ||
        false
        
            ,
            
        can_place_orders: data.can_place_orders
        ||
        false
        
            ,
            
        can_see_invoices: data.can_see_invoices
        ||
        false
        
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await contacts.setAccount( data.account || null, {
            transaction,
        });
        
        await contacts.setLocation( data.location || null, {
            transaction,
        });
        

        

        

        return contacts;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const contactsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                contact_name: item.contact_name
            ||
            null
            ,
            
                email: item.email
            ||
            null
            ,
            
                phone: item.phone
            ||
            null
            ,
            
                role_title: item.role_title
            ||
            null
            ,
            
                is_primary: item.is_primary
            ||
            false
        
            ,
            
                can_place_orders: item.can_place_orders
            ||
            false
        
            ,
            
                can_see_invoices: item.can_see_invoices
            ||
            false
        
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const contacts = await db.contacts.bulkCreate(contactsData, { transaction });

        // For each item created, replace relation files
        

        return contacts;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const contacts = await db.contacts.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.contact_name !== undefined) updatePayload.contact_name = data.contact_name;
        
        
        if (data.email !== undefined) updatePayload.email = data.email;
        
        
        if (data.phone !== undefined) updatePayload.phone = data.phone;
        
        
        if (data.role_title !== undefined) updatePayload.role_title = data.role_title;
        
        
        if (data.is_primary !== undefined) updatePayload.is_primary = data.is_primary;
        
        
        if (data.can_place_orders !== undefined) updatePayload.can_place_orders = data.can_place_orders;
        
        
        if (data.can_see_invoices !== undefined) updatePayload.can_see_invoices = data.can_see_invoices;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await contacts.update(updatePayload, {transaction});

        
        
        if (data.account !== undefined) {
            await contacts.setAccount(
              
              data.account,
              
              { transaction }
            );
        }
        
        if (data.location !== undefined) {
            await contacts.setLocation(
              
              data.location,
              
              { transaction }
            );
        }
        

        
        

        

        return contacts;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const contacts = await db.contacts.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of contacts) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of contacts) {
                await record.destroy({transaction});
            }
        });


        return contacts;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const contacts = await db.contacts.findByPk(id, options);

        await contacts.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await contacts.destroy({
            transaction
        });

        return contacts;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const contacts = await db.contacts.findOne(
            { where },
            { transaction },
        );

        if (!contacts) {
            return contacts;
        }

        const output = contacts.get({plain: true});

        
        
        
        
        
        output.locations_default_contact = await contacts.getLocations_default_contact({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.account = await contacts.getAccount({
            transaction
        });
        
        
        output.location = await contacts.getLocation({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.accounts,
        as: 'account',
        
        where: filter.account ? {
          [Op.or]: [
            { id: { [Op.in]: filter.account.split('|').map(term => Utils.uuid(term)) } },
            {
              account_name: {
                [Op.or]: filter.account.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.locations,
        as: 'location',
        
        where: filter.location ? {
          [Op.or]: [
            { id: { [Op.in]: filter.location.split('|').map(term => Utils.uuid(term)) } },
            {
              location_name: {
                [Op.or]: filter.location.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.contact_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'contact_name',
                        filter.contact_name,
                    ),
                };
            }
            
            if (filter.email) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'email',
                        filter.email,
                    ),
                };
            }
            
            if (filter.phone) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'phone',
                        filter.phone,
                    ),
                };
            }
            
            if (filter.role_title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contacts',
                        'role_title',
                        filter.role_title,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_primary) {
                where = {
                    ...where,
                is_primary: filter.is_primary,
            };
            }
            
            if (filter.can_place_orders) {
                where = {
                    ...where,
                can_place_orders: filter.can_place_orders,
            };
            }
            
            if (filter.can_see_invoices) {
                where = {
                    ...where,
                can_see_invoices: filter.can_see_invoices,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.contacts.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'contacts',
                        'contact_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.contacts.findAll({
            attributes: [ 'id', 'contact_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['contact_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.contact_name,
        }));
    }

    
};

